Index: trunk/LMDZ.MARS/deftank/field_def_physics_mars.xml
===================================================================
--- trunk/LMDZ.MARS/deftank/field_def_physics_mars.xml	(revision 3051)
+++ trunk/LMDZ.MARS/deftank/field_def_physics_mars.xml	(revision 3052)
@@ -32,4 +32,122 @@
                    unit="kg" />
 
+            <!-- tracer total mass (chemistry) -->
+            <field id="mass_co2"
+                   long_name="CO2 global mass"
+                   unit="g" />
+            <field id="mass_co"
+                   long_name="CO global mass"
+                   unit="g" />
+            <field id="mass_o"
+                   long_name="O global mass"
+                   unit="g" />
+            <field id="mass_o1d"
+                   long_name="O1d global mass"
+                   unit="g" />
+            <field id="mass_o2"
+                   long_name="O2 global mass"
+                   unit="g" />
+            <field id="mass_o3"
+                   long_name="O3 global mass"
+                   unit="g" />
+            <field id="mass_h"
+                   long_name="H global mass"
+                   unit="g" />
+            <field id="mass_h2"
+                   long_name="H2 global mass"
+                   unit="g" />
+            <field id="mass_oh"
+                   long_name="OH global mass"
+                   unit="g" />
+            <field id="mass_ho2"
+                   long_name="HO2 global mass"
+                   unit="g" />
+            <field id="mass_h2o2"
+                   long_name="H2O2 global mass"
+                   unit="g" />
+            <field id="mass_n2"
+                   long_name="N2 global mass"
+                   unit="g" />
+            <field id="mass_ar"
+                   long_name="Ar global mass"
+                   unit="g" />
+            <field id="mass_h2o_ice"
+                   long_name="H2O_ice global mass"
+                   unit="g" />
+            <field id="mass_h2o_vap"
+                   long_name="H2O_vap global mass"
+                   unit="g" />
+            <field id="mass_n"
+                   long_name="N global mass"
+                   unit="g" />
+            <field id="mass_no"
+                   long_name="NO global mass"
+                   unit="g" />
+            <field id="mass_no2"
+                   long_name="NO2 global mass"
+                   unit="g" />
+            <field id="mass_n2d"
+                   long_name="N2d global mass"
+                   unit="g" />
+            <field id="mass_ch4"
+                   long_name="CH4 global mass"
+                   unit="g" />
+            <field id="mass_he"
+                   long_name="He global mass"
+                   unit="g" />
+
+            <!-- tracer total mass (ions) -->
+            <field id="mass_co2plus"
+                   long_name="CO2+ global mass"
+                   unit="g" />
+            <field id="mass_oplus"
+                   long_name="O+ global mass"
+                   unit="g" />
+            <field id="mass_o2plus"
+                   long_name="O2+ global mass"
+                   unit="g" />
+            <field id="mass_coplus"
+                   long_name="CO+ global mass"
+                   unit="g" />
+            <field id="mass_o2plus"
+                   long_name="O2+ global mass"
+                   unit="g" />
+            <field id="mass_coplus"
+                   long_name="CO+ global mass"
+                   unit="g" />
+            <field id="mass_cplus"
+                   long_name="C+ global mass"
+                   unit="g" />
+            <field id="mass_nplus"
+                   long_name="N+ global mass"
+                   unit="g" />
+            <field id="mass_noplus"
+                   long_name="NO+ global mass"
+                   unit="g" />
+            <field id="mass_n2plus"
+                   long_name="N2+ global mass"
+                   unit="g" />
+            <field id="mass_hplus"
+                   long_name="H+ global mass"
+                   unit="g" />
+            <field id="mass_hco2plus"
+                   long_name="HCO2+ global mass"
+                   unit="g" />
+            <field id="mass_hcoplus"
+                   long_name="HCO+ global mass"
+                   unit="g" />
+            <field id="mass_h2oplus"
+                   long_name="H2O+ global mass"
+                   unit="g" />
+            <field id="mass_h3oplus"
+                   long_name="H3O+ global mass"
+                   unit="g" />
+            <field id="mass_ohplus"
+                   long_name="OH+ global mass"
+                   unit="g" />
+            <field id="mass_elec"
+                   long_name="electron global mass"
+                   unit="g" />
+
         </field_group>    
 
@@ -173,37 +291,41 @@
                    long_name="Longwave radiation at the surface on slope 07" 
                    unit="W.m-2" />
+
             <field id="fluxtop_lw"
-                   long_name="Longwave radiation at the top of the atmosphere" 
+                   long_name="Longwave radiation to space at the top of the atmosphere" 
+                   unit="W.m-2" />
+            <field id="fluxtop_dn_sw"
+                   long_name="Incoming Solar radiative flux from space" 
+                   unit="W.m-2" />
+            <field id="fluxtop_up_sw"
+                   long_name="Outgoing Solar radiative flux to space" 
+                   unit="W.m-2" />
+
+            <field id="fluxsurf_dn_sw"
+                   long_name="Incoming shortwave radiation at the surface"  
+                   unit="W.m-2" />
+            <field id="fluxsurf_dn_sw_slope01"
+                   long_name="Incoming shortwave radiation at the surface on slope 01"  
+                   unit="W.m-2" />
+            <field id="fluxsurf_dn_sw_slope02"
+                   long_name="Incoming shortwave radiation at the surface on slope 02"  
+                   unit="W.m-2" />
+            <field id="fluxsurf_dn_sw_slope03"
+                   long_name="Incoming shortwave radiation at the surface on slope 03"  
+                   unit="W.m-2" />
+            <field id="fluxsurf_dn_sw_slope04"
+                   long_name="Incoming shortwave radiation at the surface on slope 04"  
+                   unit="W.m-2" />
+            <field id="fluxsurf_dn_sw_slope05"
+                   long_name="Incoming shortwave radiation at the surface on slope 05"  
+                   unit="W.m-2" />
+            <field id="fluxsurf_dn_sw_slope06"
+                   long_name="Incoming shortwave radiation at the surface on slope 06"  
+                   unit="W.m-2" />
+            <field id="fluxsurf_dn_sw_slope07"
+                   long_name="Incoming shortwave radiation at the surface on slope 07"  
                    unit="W.m-2" />
             <field id="fluxtop_up_sw"
                    long_name="Upward shortwave radiation at the top of the atmosphere" 
-                   unit="W.m-2" />
-            <field id="fluxtop_dn_sw"
-                   long_name="Incoming shortwave radiation at the top of the atmosphere" 
-                   unit="W.m-2" />
-
-            <field id="fluxsurf_dn_sw"
-                   long_name="Incoming shortwave radiation at the surface"  
-                   unit="W.m-2" />
-            <field id="fluxsurf_dn_sw_slope01"
-                   long_name="Incoming shortwave radiation at the surface on slope 01"  
-                   unit="W.m-2" />
-            <field id="fluxsurf_dn_sw_slope02"
-                   long_name="Incoming shortwave radiation at the surface on slope 02"  
-                   unit="W.m-2" />
-            <field id="fluxsurf_dn_sw_slope03"
-                   long_name="Incoming shortwave radiation at the surface on slope 03"  
-                   unit="W.m-2" />
-            <field id="fluxsurf_dn_sw_slope04"
-                   long_name="Incoming shortwave radiation at the surface on slope 04"  
-                   unit="W.m-2" />
-            <field id="fluxsurf_dn_sw_slope05"
-                   long_name="Incoming shortwave radiation at the surface on slope 05"  
-                   unit="W.m-2" />
-            <field id="fluxsurf_dn_sw_slope06"
-                   long_name="Incoming shortwave radiation at the surface on slope 06"  
-                   unit="W.m-2" />
-            <field id="fluxsurf_dn_sw_slope07"
-                   long_name="Incoming shortwave radiation at the surface on slope 07"  
                    unit="W.m-2" />
             
@@ -437,8 +559,122 @@
                    unit="kg/m2" />
 
-            
             <field id="co2condens_zfallice"
                    long_name="CO2 ice tendency on the surface"
                    unit="kg.m-2.s-1" />
+
+            <!-- tracer columns (chemistry) -->
+            <field id="c_co2" 
+                   long_name="CO2 column" 
+                   unit="mol.cm-2" />
+            <field id="c_co" 
+                   long_name="CO column" 
+                   unit="mol.cm-2" />
+            <field id="c_o" 
+                   long_name="O column" 
+                   unit="mol.cm-2" />
+            <field id="c_o1d" 
+                   long_name="O1d column" 
+                   unit="mol.cm-2" />
+            <field id="c_o2" 
+                   long_name="O2 column" 
+                   unit="mol.cm-2" />
+            <field id="c_o3" 
+                   long_name="O3 column" 
+                   unit="mol.cm-2" />
+            <field id="c_h" 
+                   long_name="H column" 
+                   unit="mol.cm-2" />
+            <field id="c_h2" 
+                   long_name="H2 column" 
+                   unit="mol.cm-2" />
+            <field id="c_oh" 
+                   long_name="OH column" 
+                   unit="mol.cm-2" />
+            <field id="c_ho2" 
+                   long_name="HO2 column" 
+                   unit="mol.cm-2" />
+            <field id="c_h2o2" 
+                   long_name="H2 column" 
+                   unit="mol.cm-2" />
+            <field id="c_n2" 
+                   long_name="N2 column" 
+                   unit="mol.cm-2" />
+            <field id="c_ar" 
+                   long_name="Ar column" 
+                   unit="mol.cm-2" />
+            <field id="c_h2o_ice" 
+                   long_name="H2O_ice column" 
+                   unit="mol.cm-2" />
+            <field id="c_h2o_vap" 
+                   long_name="H2O_vap column" 
+                   unit="mol.cm-2" />
+            <field id="c_n" 
+                   long_name="N column" 
+                   unit="mol.cm-2" />
+            <field id="c_no" 
+                   long_name="NO column" 
+                   unit="mol.cm-2" />
+            <field id="c_no2" 
+                   long_name="NO2 column" 
+                   unit="mol.cm-2" />
+            <field id="c_n2d" 
+                   long_name="N2d column" 
+                   unit="mol.cm-2" />
+            <field id="c_ch4" 
+                   long_name="CH4 column" 
+                   unit="mol.cm-2" />
+            <field id="c_he" 
+                   long_name="He column" 
+                   unit="mol.cm-2" />
+
+            <!-- ions -->
+            <field id="c_co2plus" 
+                   long_name="CO2+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_oplus" 
+                   long_name="O+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_o2plus" 
+                   long_name="O2+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_coplus" 
+                   long_name="CO+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_coplus" 
+                   long_name="CO+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_cplus" 
+                   long_name="C+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_nplus" 
+                   long_name="N+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_noplus" 
+                   long_name="NO+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_n2plus" 
+                   long_name="N2+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_hplus" 
+                   long_name="H+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_hco2plus" 
+                   long_name="HCO2+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_hcoplus" 
+                   long_name="HCO+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_h2oplus" 
+                   long_name="H2O+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_h3oplus" 
+                   long_name="H3O+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_ohplus" 
+                   long_name="OH+ column" 
+                   unit="mol.cm-2" />
+            <field id="c_elec" 
+                   long_name="electron column" 
+                   unit="mol.cm-2" />
 
             <!-- Thermals parametrization -->
@@ -518,8 +754,14 @@
                    unit="K.s-1" />
 
-            <!-- tracers -->
+            <!-- tracers (CO2 and water) -->
             <field id="co2" 
-                   long_name="co2 mass mixing ratio" 
-                   unit="kg/kg" />
+                   long_name="CO2 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_co2" 
+                   long_name="CO2 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_co2" 
+                   long_name="CO2 number density" 
+                   unit="cm-3" />
             <field id="h2o_ice" 
                    long_name="water ice mass mixing ratio" 
@@ -528,4 +770,10 @@
                    long_name="water ice volume mixing ratio" 
                    unit="mol/mol" />
+            <field id="vmr_h2o_ice" 
+                   long_name="water ice volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_h2o_ice" 
+                   long_name="water ice number density" 
+                   unit="cm-3" />
             <field id="h2o_vap" 
                    long_name="water vapor mass mixing ratio" 
@@ -534,5 +782,201 @@
                    long_name="water vapor volume mixing ratio" 
                    unit="mol/mol" />
-        
+            <field id="vmr_h2o_vap" 
+                   long_name="water vapor volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_h2o_vap" 
+                   long_name="water vapor number density" 
+                   unit="cm-3" />
+       
+            <!-- tracers (chemistry) -->
+            <field id="co" 
+                   long_name="CO mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_co" 
+                   long_name="CO volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_co" 
+                   long_name="CO number density" 
+                   unit="cm-3" />
+            <field id="o" 
+                   long_name="O mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_o" 
+                   long_name="O volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_o" 
+                   long_name="O number density" 
+                   unit="cm-3" />
+            <field id="o1d" 
+                   long_name="O1d mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_o1d" 
+                   long_name="O1d volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_o1d" 
+                   long_name="O1d number density" 
+                   unit="cm-3" />
+            <field id="o2" 
+                   long_name="O2 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_o2" 
+                   long_name="O2 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_o2" 
+                   long_name="O2 number density" 
+                   unit="cm-3" />
+            <field id="o3" 
+                   long_name="O3 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_o3" 
+                   long_name="O3 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_o3" 
+                   long_name="O3 number density" 
+                   unit="cm-3" />
+            <field id="h" 
+                   long_name="H mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_h" 
+                   long_name="H volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_h" 
+                   long_name="H number density" 
+                   unit="cm-3" />
+            <field id="h2" 
+                   long_name="H2 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_h2" 
+                   long_name="H2 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_h2" 
+                   long_name="H2 number density" 
+                   unit="cm-3" />
+            <field id="oh" 
+                   long_name="OH mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_oh" 
+                   long_name="OH volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_oh" 
+                   long_name="OH number density" 
+                   unit="cm-3" />
+            <field id="ho2" 
+                   long_name="HO2 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_ho2" 
+                   long_name="HO2 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_ho2" 
+                   long_name="HO2 number density" 
+                   unit="cm-3" />
+            <field id="h2o2" 
+                   long_name="H2O2 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_h2o2" 
+                   long_name="H2O2 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_h2o2" 
+                   long_name="H2O2 number density" 
+                   unit="cm-3" />
+            <field id="n2" 
+                   long_name="N2 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_n2" 
+                   long_name="N2 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_n2" 
+                   long_name="N2 number density" 
+                   unit="cm-3" />
+            <field id="ar" 
+                   long_name="Ar mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_ar" 
+                   long_name="Ar volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_ar" 
+                   long_name="Ar number density" 
+                   unit="cm-3" />
+            <field id="num_n" 
+                   long_name="N number density" 
+                   unit="cm-3" />
+            <field id="num_no" 
+                   long_name="NO number density" 
+                   unit="cm-3" />
+            <field id="num_no2" 
+                   long_name="NO2 number density" 
+                   unit="cm-3" />
+            <field id="num_n2d" 
+                   long_name="N2d number density" 
+                   unit="cm-3" />
+            <field id="ch4" 
+                   long_name="CH4 mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_ch4" 
+                   long_name="CH4 volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_ch4" 
+                   long_name="CH4 number density" 
+                   unit="cm-3" />
+            <field id="he" 
+                   long_name="He mass mixing ratio" 
+                   unit="kg/kg" />
+            <field id="vmr_he" 
+                   long_name="He volume mixing ratio" 
+                   unit="mol/mol" />
+            <field id="num_he" 
+                   long_name="He number density" 
+                   unit="cm-3" />
+
+            <!-- ions -->
+            <field id="num_co2plus" 
+                   long_name="CO2+ number density" 
+                   unit="cm-3" />
+            <field id="num_oplus" 
+                   long_name="O+ number density" 
+                   unit="cm-3" />
+            <field id="num_o2plus" 
+                   long_name="O2+ number density" 
+                   unit="cm-3" />
+            <field id="num_coplus" 
+                   long_name="CO+ number density" 
+                   unit="cm-3" />
+            <field id="num_coplus" 
+                   long_name="CO+ number density" 
+                   unit="cm-3" />
+            <field id="num_cplus" 
+                   long_name="C+ number density" 
+                   unit="cm-3" />
+            <field id="num_nplus" 
+                   long_name="N+ number density" 
+                   unit="cm-3" />
+            <field id="num_noplus" 
+                   long_name="NO+ number density" 
+                   unit="cm-3" />
+            <field id="num_n2plus" 
+                   long_name="N2+ number density" 
+                   unit="cm-3" />
+            <field id="num_hplus" 
+                   long_name="H+ number density" 
+                   unit="cm-3" />
+            <field id="num_hco2plus" 
+                   long_name="HCO2+ number density" 
+                   unit="cm-3" />
+            <field id="num_hcoplus" 
+                   long_name="HCO+ number density" 
+                   unit="cm-3" />
+            <field id="num_h2oplus" 
+                   long_name="H2O+ number density" 
+                   unit="cm-3" />
+            <field id="num_h3oplus" 
+                   long_name="H3O+ number density" 
+                   unit="cm-3" />
+            <field id="num_ohplus" 
+                   long_name="OH+ number density" 
+                   unit="cm-3" />
+            <field id="num_elec" 
+                   long_name="electron number density" 
+                   unit="cm-3" />
+
             <!-- Dust cycle parametrization -->
             <field id="reffdust" 