Index: trunk/LMDZ.MARS/deftank/README
===================================================================
--- trunk/LMDZ.MARS/deftank/README	(revision 3052)
+++ trunk/LMDZ.MARS/deftank/README	(revision 3058)
@@ -15,13 +15,14 @@
 - run.def.lonxlatxalt illustrate cases for different spatial grids
   (typically the GCM is run at 64x48 horizontal resolution)
-- z2sig.def is the current standard vertical grid definition (use 54 layers
+- z2sig.def.MCD6 is the current standard vertical grid definition (use 54 layers
   if running up to ~120km, e.g. water & dust cycle simulations, 73 layers
-  if including chemistry and thermosphere up to ~300km)
+  if including chemistry and thermosphere up to ~250km)
 - *.GCM5 files correspond to GCM5 version using z2sig.def.MCD5
   up to ~120km (32 levels) or ~300km (49 levels)
 - *.MCD5 files correspond to what was used to generate MCDv5.x simulations
 - *.GCM6 files correspond to GCM6 version with improved dust and water cycles
-  up to ~120km (54 levels)
+  up to ~120km (54 levels) using z2sig.def.MCD6
 - *.MCD6 files correspond to what was used to generate MCDv6.1 simulations
+  up to ~250km (73 levels) using z2sig.def.MCD6
 
 >> XML FILES
Index: trunk/LMDZ.MARS/deftank/callphys.def.GCM6
===================================================================
--- trunk/LMDZ.MARS/deftank/callphys.def.GCM6	(revision 3052)
+++ trunk/LMDZ.MARS/deftank/callphys.def.GCM6	(revision 3058)
@@ -2,5 +2,5 @@
 ##~~~~~~~~~~~~~~~
 #Directory where external input files are:
-datadir=/users/lmdz/WWW/planets/mars/datadir
+datadir=datadir
 
 #Run with or without tracer transport ?
@@ -38,5 +38,5 @@
 #  ...
 #  =35 Mars Year 35 from observers assimilation
-iaervar = 35
+iaervar = 8
 # Dust opacity at 610 Pa (when constant, i.e. for the iaervar=1 case)
 tauvis=0.2
@@ -82,6 +82,23 @@
 # call thermal conduction in the soil ?
 callsoil = .true.
+
+##Gravity Waves
 # call Lott's gravity wave/subgrid topography scheme ?
 calllott  = .true.
+# call Lott's non-orographic gravity waves scheme?
+calllott_nonoro=.true.
+#Eliassen-Palm FLux(only if calllott_nonoro=.true.)
+nonoro_gwd_epflux_max=5.E-4
+# saturation parameter non-orographic gravity waves(only if calllott_nonoro=.true.)
+nonoro_gwd_sat=1.5
+# value of the dissaption coefficiet(only if calllott_nonoro=.true.)
+nonoro_gwd_rdiss=0.15
+# value of the max wave number
+nonoro_gwd_kmax=1.E-4
+# value of the min wave number
+nonoro_gwd_kmin=7.E-6
+# value to control the launch altitude
+nonoro_gwd_xlaunch=0.6
+
 # Impose polar cap surface albedos as observed by TES?
 TESicealbedo = .true.
Index: trunk/LMDZ.MARS/deftank/callphys.def.MCD6
===================================================================
--- trunk/LMDZ.MARS/deftank/callphys.def.MCD6	(revision 3052)
+++ trunk/LMDZ.MARS/deftank/callphys.def.MCD6	(revision 3058)
@@ -189,5 +189,5 @@
 frost_albedo_threshold = 0.005
 # Frost metamorphism into old ice
-refill_watercap = .true.
+refill_watercap = .false.
 frost_metam_threshold = 0.05
 # WATER: Water ice thermal inertia (old ice and fresh frost)
Index: trunk/LMDZ.MARS/deftank/callphys.def.notracers
===================================================================
--- trunk/LMDZ.MARS/deftank/callphys.def.notracers	(revision 3052)
+++ 	(revision )
@@ -1,142 +1,0 @@
-##General options
-##~~~~~~~~~~~~~~~
-#Run with or without tracer transport ?
-tracer=.false.
-
-#Where are the external files (dust, topography; chemistry,...)
-#datadir=/u/forget/WWW/datagcm/datafile
-
-#Diurnal cycle ?  if diurnal=False, diurnal averaged solar heating
-diurnal=.true.
-
-#Seasonal cycle ? if season=False, Ls stays constant, to value set in "start"
-season = .true.   
-
-#write some more output on the screen ?
-lwrite = .false.    
-
-#Save statistics in file "stats.nc" ?
-callstats =.true.
-
-#Save EOF profiles in file "profiles" for Climate Database?
-calleofdump = .false.
-
-## Dust scenario. Used if the dust is prescribed (i.e. if tracer=F or active=F)
-## ~~~~~~~~~~~~~
-#  =1 Dust opt.deph read in startfi; =2 Viking scenario; =3 MGS scenario,
-#  =4 Mars Year 24 from TES assimilation (old version of MY24; dust_tes.nc file)
-#  =6 "cold" (low dust) scenario ; =7 "warm" (high dust) scenario
-#  =24 Mars Year 24  ; =25 Mars Year 25 (year with a global dust storm) ; ...
-#  =30 Mars Year 30 
-iaervar = 24 
-# Dust opacity at 610 Pa (when constant, i.e. for the iaervar=1 case)
-tauvis=0.2
-# Dust vertical distribution: 
-# (=0: old distrib. (Pollack90), =1: top set by "topdustref",
-#  =2: Viking scenario; =3 MGS scenario)
-iddist  = 3
-# Dust top altitude (km). (Matters only if iddist=1)
-topdustref = 55.
-
-## Physical Parameterizations :
-## ~~~~~~~~~~~~~~~~~~~~~~~~~~
-# call radiative transfer ?
-callrad   = .true.
-# call NLTE radiative schemes ?   matters only if callrad=T
-callnlte = .true.
-# NLTE 15um scheme to use.
-# 0-> Old scheme, static oxygen
-# 1-> Old scheme, dynamic oxygen
-# 2-> New scheme
-nltemodel = 1
-# call CO2 NIR absorption ?   matters only if callrad=T
-callnirco2 = .true.
-# NIR NLTE correction ? matters only if callnirco2=T
-nircorr=1
-# call turbulent vertical diffusion ?
-calldifv  = .true.
-# call convective adjustment ?
-calladj  = .true.
-# call CO2 condensation ?
-callcond =.true.
-# call thermal conduction in the soil ?
-callsoil = .true.
-# call Lott's gravity wave/subgrid topography scheme ?
-calllott  = .true.
-# Impose polar cap surface albedos as observed by TES?
-TESicealbedo = .true.
-## Coefficient for Northern cap albedoes
-TESice_Ncoef=1.6
-## Coefficient for Southern cap albedoes
-TESice_Scoef=1.6
-
-
-## Radiative transfer options :
-## ~~~~~~~~~~~~~~~~~~~~~~~~~~
-# the rad.transfer is computed every "iradia" physical timestep
-iradia    = 1
-# Output of the exchange coefficient mattrix ? for diagnostic only
-callg2d  = .false.
-# Rayleigh scattering : (should be .false. for now)
-rayleigh  = .false.
-
-## Tracer (dust water, ice and/or chemical species) options (used if tracer=T):
-## ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-# DUST: Transported dust ? (if >0, use 'dustbin' dust bins)
-dustbin    = 0
-# DUST: Radiatively active dust ? (matters if dustbin>0)
-active  = .false.
-# DUST: use mass and number mixing ratios to predict dust size ?
-doubleq   = .false.
-# DUST: lifted by GCM surface winds ?
-lifting = .false.
-# DUST: lifted by dust devils ?
-callddevil = .false.
-# DUST: Scavenging by CO2 snowfall ?
-scavenging = .false.
-# DUST/WATERICE: Gravitationnal sedimentation ?
-sedimentation = .false.
-# WATERICE: Radiatively active transported atmospheric water ice ?
-activice   = .false.
-# WATER: Compute water cycle
-water = .false.
-# WATER: current permanent caps at both poles. True IS RECOMMENDED
-#        (with .true., North cap is a source of water and South pole
-#         is a cold trap)
-caps  = .true.
-# PHOTOCHEMISTRY: include chemical species 
-photochem  = .false.
-
-# SCATTERERS: set number of scatterers. must be compliant with preceding options.
-naerkind = 1
-
-## Thermospheric options (relevant if tracer=T) :
-##~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-# call thermosphere ?
-callthermos = .false.
-# WATER: included without cycle (only if water=.false.)
-thermoswater = .false.
-# call thermal conduction ? (only if callthermos=.true.)
-callconduct = .false.
-# call molecular viscosity ? (only if callthermos=.true.)
-callmolvis = .false.
-# call molecular diffusion ? (only if callthermos=.true.)
-callmoldiff = .false.
-# call thermospheric photochemistry ? (only if callthermos=.true.)
-thermochem = .false.
-# call EUV heating ? (only if callthermos=.true.)
-calleuv=.false.
-#Method to include solar variability?
-#0-> Old method   1-> Variability with E10.7 as observed
-solvarmod=1
-# date for solar flux calculation: (1985 < date < 2002)
-## (Solar min=1996.4 ave=1993.4 max=1990.6) ; Only used if solvarmod=0
-solarcondate = 1993.4
-#Solar variability as observed for MY? (must bebetween MY23 and MY30)
-# (only matters if solvarmod=1)
-solvaryear=24
-# value for the UV heating efficiency
-##(experimental values between 0.19 and 0.23, lower values may
-## be used to compensate for low 15 um cooling)
-euveff = 0.21       
-
Index: trunk/LMDZ.MARS/deftank/z2sig.def
===================================================================
--- trunk/LMDZ.MARS/deftank/z2sig.def	(revision 3052)
+++ 	(revision )
@@ -1,74 +1,0 @@
-10.00000     H: atmospheric scale height (km) (used as a reference only)
-  2.0736000E-03  2.0736000E-03
-  1.5735000E-02  1.3661400E-02
-  6.0015101E-02  4.4280101E-02
-  0.1633440      0.1033289    
-  0.3635800      0.2002360    
-  0.7080070      0.3444270    
-   1.193340      0.4853330    
-   1.738673      0.5453330    
-   2.311467      0.5727936    
-   2.913104      0.6016369    
-   3.545036      0.6319327    
-   4.208790      0.6637540    
-   4.905968      0.6971779    
-   5.638253      0.7322845    
-   6.407412      0.7691593    
-   7.215303      0.8078909    
-   8.063875      0.8485727    
-   8.955178      0.8913031    
-   9.891363      0.9361849    
-   10.87469      0.9833269    
-   11.90753       1.032844    
-   12.99239       1.084852    
-   14.13187       1.139481    
-   15.32873       1.196860    
-   16.58586       1.257130    
-   17.90629       1.320433    
-   19.29321       1.386923    
-   20.74998       1.456762    
-   22.28009       1.530119    
-   23.88726       1.607170    
-   25.57536       1.688099    
-   27.34847       1.773104    
-   29.21086       1.862391    
-   31.16703       1.956171    
-   33.22170       2.054676    
-   35.37984       2.158138    
-   37.64666       2.266815    
-   40.02762       2.380962    
-   42.52848       2.500858    
-   45.15526       2.626785    
-   47.91433       2.759064    
-   50.81232       2.897995    
-   53.90257       3.090248    
-   57.32509       3.422523    
-   61.13848       3.813385    
-   65.41566       4.277184    
-   70.24855       4.832886    
-   75.75449       5.505936    
-   82.08560       6.331116    
-   89.08560       7.000000    
-   96.08560       7.000000    
-   103.0856       7.000000    
-   110.0856       7.000000    
-   117.0856       7.000000    
-   124.0856       7.000000    
-   131.0856       7.000000    
-   138.0856       7.000000    
-   145.0856       7.000000    
-   152.0856       7.000000    
-   159.0856       7.000000    
-   166.0856       7.000000    
-   173.0856       7.000000    
-   180.0856       7.000000    
-   187.0856       7.000000    
-   194.0856       7.000000    
-   201.0856       7.000000    
-   208.0856       7.000000    
-   215.0856       7.000000    
-   222.0856       7.000000    
-   229.0856       7.000000    
-   236.0856       7.000000    
-   243.0856       7.000000    
-   250.0856       7.000000    
Index: trunk/LMDZ.MARS/deftank/z2sig.def.MCD6
===================================================================
--- trunk/LMDZ.MARS/deftank/z2sig.def.MCD6	(revision 3058)
+++ trunk/LMDZ.MARS/deftank/z2sig.def.MCD6	(revision 3058)
@@ -0,0 +1,74 @@
+10.00000     H: atmospheric scale height (km) (used as a reference only)
+  2.0736000E-03  2.0736000E-03
+  1.5735000E-02  1.3661400E-02
+  6.0015101E-02  4.4280101E-02
+  0.1633440      0.1033289    
+  0.3635800      0.2002360    
+  0.7080070      0.3444270    
+   1.193340      0.4853330    
+   1.738673      0.5453330    
+   2.311467      0.5727936    
+   2.913104      0.6016369    
+   3.545036      0.6319327    
+   4.208790      0.6637540    
+   4.905968      0.6971779    
+   5.638253      0.7322845    
+   6.407412      0.7691593    
+   7.215303      0.8078909    
+   8.063875      0.8485727    
+   8.955178      0.8913031    
+   9.891363      0.9361849    
+   10.87469      0.9833269    
+   11.90753       1.032844    
+   12.99239       1.084852    
+   14.13187       1.139481    
+   15.32873       1.196860    
+   16.58586       1.257130    
+   17.90629       1.320433    
+   19.29321       1.386923    
+   20.74998       1.456762    
+   22.28009       1.530119    
+   23.88726       1.607170    
+   25.57536       1.688099    
+   27.34847       1.773104    
+   29.21086       1.862391    
+   31.16703       1.956171    
+   33.22170       2.054676    
+   35.37984       2.158138    
+   37.64666       2.266815    
+   40.02762       2.380962    
+   42.52848       2.500858    
+   45.15526       2.626785    
+   47.91433       2.759064    
+   50.81232       2.897995    
+   53.90257       3.090248    
+   57.32509       3.422523    
+   61.13848       3.813385    
+   65.41566       4.277184    
+   70.24855       4.832886    
+   75.75449       5.505936    
+   82.08560       6.331116    
+   89.08560       7.000000    
+   96.08560       7.000000    
+   103.0856       7.000000    
+   110.0856       7.000000    
+   117.0856       7.000000    
+   124.0856       7.000000    
+   131.0856       7.000000    
+   138.0856       7.000000    
+   145.0856       7.000000    
+   152.0856       7.000000    
+   159.0856       7.000000    
+   166.0856       7.000000    
+   173.0856       7.000000    
+   180.0856       7.000000    
+   187.0856       7.000000    
+   194.0856       7.000000    
+   201.0856       7.000000    
+   208.0856       7.000000    
+   215.0856       7.000000    
+   222.0856       7.000000    
+   229.0856       7.000000    
+   236.0856       7.000000    
+   243.0856       7.000000    
+   250.0856       7.000000    