Index: trunk/LMDZ.TITAN/deftank/callphys.def
===================================================================
--- trunk/LMDZ.TITAN/deftank/callphys.def	(revision 3085)
+++ trunk/LMDZ.TITAN/deftank/callphys.def	(revision 3090)
@@ -90,5 +90,5 @@
 # Chemistry is computed every "ichim" phys. timestep
 ichim      = 20
-# Infinite tank of CH4 ?
+# Infinite tank of CH4 ? (.false. == lakes at the poles)
 resCH4_inf = .false.
 
@@ -107,5 +107,5 @@
 opt4clouds = .true.
 # Cloudy fraction in the Clear / Dark column method ?
-Fcloudy    = 0.15
+Fcloudy    = 0.2
 # Adjustment of ssca albedo for cloudy dropplet ?
 Fssa       = 0.90
Index: trunk/LMDZ.TITAN/deftank/diagfi.def
===================================================================
--- trunk/LMDZ.TITAN/deftank/diagfi.def	(revision 3085)
+++ trunk/LMDZ.TITAN/deftank/diagfi.def	(revision 3090)
@@ -1,18 +1,0 @@
-ISR
-ASR
-pphi
-Ls
-tsurf
-ps
-temp
-u
-v
-w
-p
-q2
-sensibFlux
-zdtsw
-zdtlw
-zdtdyn
-zdudif
-zdudyn
Index: trunk/LMDZ.TITAN/deftank/gases.def
===================================================================
--- trunk/LMDZ.TITAN/deftank/gases.def	(revision 3085)
+++ trunk/LMDZ.TITAN/deftank/gases.def	(revision 3090)
@@ -1,3 +1,3 @@
-# gases
+# Gases
 10
 0.985
Index: trunk/LMDZ.TITAN/deftank/profile.def
===================================================================
--- trunk/LMDZ.TITAN/deftank/profile.def	(revision 3085)
+++ trunk/LMDZ.TITAN/deftank/profile.def	(revision 3090)
@@ -1,3 +1,3 @@
-#profile (Reference CH4 vertical profile (mol/mol) : surface->top)
+# Profile (Reference CH4 vertical profile (mol/mol) : Surface ---> Top)
 0.0565
 0.0567
Index: trunk/LMDZ.TITAN/deftank/run.def
===================================================================
--- trunk/LMDZ.TITAN/deftank/run.def	(revision 3085)
+++ 	(revision )
@@ -1,124 +1,0 @@
-#
-#----------------------------------------------------------------------- 
-#Parametres de controle du run:                                          
-#------------------------------                                          
-
-# Planete
-planet_type = titan
-
-# Nombre de jours d'integration                                         
-     nday=11
-
-# nombre de pas par jour (multiple de iperiod) ( ici pour  dt = 1 min )      
- day_step = 8000
-
-# periode pour le pas Matsuno (en pas)                                  
-  iperiod=5
-
-# periode de sortie des variables de controle (en pas)                  
-  iconser=500
-
-# periode d'ecriture du fichier histoire (en jour)                      
-    iecri=100
-
-# periode de stockage fichier histmoy (en jour)                         
- periodav=60.
-
-# periode de la dissipation (en pas)                                    
-  dissip_period=5
-
-# choix de l'operateur de dissipation (star ou  non star )              
- lstardis=.true.
-
-# avec ou sans coordonnee hybrides
- hybrid=.true.
-
-# nombre d'iterations de l'operateur de dissipation   gradiv            
-nitergdiv=1
-
-# nombre d'iterations de l'operateur de dissipation  nxgradrot          
-nitergrot=2
-
-# nombre d'iterations de l'operateur de dissipation  divgrad            
-   niterh=2
-
-# temps de dissipation des plus petites long.d ondes pour u,v (gradiv)  
- tetagdiv=50000.
-
-# temps de dissipation des plus petites long.d ondes pour u,v(nxgradrot)
- tetagrot=50000.
-
-# temps de dissipation des plus petites long.d ondes pour  h ( divgrad) 
- tetatemp=50000.
-
-# Facteur d'amplification de la dissip en haut du modele
-  dissip_fac_up = 30.
-
-# Pression (Pa) au bas la transition mid / up
-   dissip_pupstart = 1.e1
-
-# coefficient pour gamdissip                                            
-  coefdis=0.
-
-# choix du shema d'integration temporelle (Matsuno ou Matsuno-leapfrog) 
-  purmats=.false.
-
-# avec ou sans physique                                                 
-   physic=.true.
-
-# periode de la physique (en pas)                                       
-  iphysiq=40
-
-# Titan: marees gravitationnelles
-  tidal=.true.
-
-# choix d'une grille reguliere                                          
-  grireg=.true.
-
-# frequence (en pas) de l'ecriture du fichier diagfi               
- ecritphy=2000
-
-# longitude en degres du centre du zoom                                 
-   clon=0.
-
-# latitude en degres du centre du zoom                                  
-   clat=0.
-
-# facteur de grossissement du zoom,selon longitude                      
-  grossismx=1.
-
-# facteur de grossissement du zoom ,selon latitude                      
- grossismy=1.
-
-#  Fonction  f(y)  hyperbolique  si = .true.  , sinon  sinusoidale         
-  fxyhypb=.false.
-
-# extension en longitude  de la zone du zoom  ( fraction de la zone totale)
-   dzoomx= 0.
-
-# extension en latitude de la zone  du zoom  ( fraction de la zone totale)
-   dzoomy=0.
-
-#  raideur du zoom en  X
-    taux=2.
-
-#  raideur du zoom en  Y
-    tauy=2.
-
-#  Fonction  f(y) avec y = Sin(latit.) si = .TRUE. ,  Sinon  y = latit.
-  ysinus= .false.
-
-# Avec sponge layer
-  callsponge  = .true.
-
-# Sponge:  mode0(u=v=0), mode1(u=umoy,v=0), mode2(u=umoy,v=vmoy)
-  mode_sponge= 2
-
-# Sponge : nsponge
-  nsponge = 5
-
-# Sponge:  tetasponge (secondes)
-  tetasponge = 10000
-
-# some definitions for the physics, in file 'callphys.def'
-INCLUDEDEF=callphys.def
Index: trunk/LMDZ.TITAN/deftank/run.def.11
===================================================================
--- trunk/LMDZ.TITAN/deftank/run.def.11	(revision 3085)
+++ trunk/LMDZ.TITAN/deftank/run.def.11	(revision 3090)
@@ -1,6 +1,5 @@
-#
-#----------------------------------------------------------------------- 
-#Parametres de controle du run:                                          
-#------------------------------                                          
+# ----------------------------------------------------------------------- 
+# Parametres de controle du run :
+# ----------------------------------------------------------------------- 
 
 # Planete
@@ -8,120 +7,120 @@
 
 # Nombre de jours d'integration                                         
-     nday=11
+nday = 11
 
-# nombre de pas par jour (multiple de iperiod) ( ici pour  dt = 1 min )      
- day_step = 8000
+# Nombre de pas par jour (multiple de iperiod) (ici pour dt = 1 min)
+day_step = 8000
 
-# periode pour le pas Matsuno (en pas)                                  
-  iperiod=5
+# Periode pour le pas Matsuno (en pas)                        
+iperiod = 5
 
-# periode de sortie des variables de controle (en pas)                  
-  iconser=500
+# Periode de sortie des variables de controle (en pas)
+iconser = 1000
 
-# periode d'ecriture du fichier histoire (en jour)                      
-    iecri=100
+# Periode d'ecriture du fichier histoire (en jour)
+iecri = 100
 
-# periode de stockage fichier histmoy (en jour)                         
- periodav=60.
+# Periode de stockage fichier histmoy (en jour)
+periodav = 60.
 
-# periode de la dissipation (en pas)                                    
-  dissip_period=5
+# Periode de la dissipation (en pas)
+dissip_period = 5
 
-# choix de l'operateur de dissipation (star ou  non star )              
- lstardis=.true.
+# Choix de l'operateur de dissipation (star ou non star)
+lstardis = .true.
 
-# avec ou sans coordonnee hybrides
- hybrid=.true.
+# Avec ou sans coordonnee hybrides
+hybrid = .true.
 
-# nombre d'iterations de l'operateur de dissipation   gradiv            
-nitergdiv=1
+# Nombre d'iterations de l'operateur de dissipation gradiv
+nitergdiv = 1
 
-# nombre d'iterations de l'operateur de dissipation  nxgradrot          
-nitergrot=2
+# Nombre d'iterations de l'operateur de dissipation nxgradrot
+nitergrot = 2
 
-# nombre d'iterations de l'operateur de dissipation  divgrad            
-   niterh=2
+# Nombre d'iterations de l'operateur de dissipation divgrad
+niterh = 2
 
-# temps de dissipation des plus petites long.d ondes pour u,v (gradiv)  
- tetagdiv=50000.
+# Temps de dissipation des plus petites long. d'ondes pour u,v (gradiv)
+tetagdiv = 25000.
 
-# temps de dissipation des plus petites long.d ondes pour u,v(nxgradrot)
- tetagrot=50000.
+# Temps de dissipation des plus petites long. d'ondes pour u,v (nxgradrot)
+tetagrot = 25000.
 
-# temps de dissipation des plus petites long.d ondes pour  h ( divgrad) 
- tetatemp=50000.
+# Temps de dissipation des plus petites long. d'ondes pour h (divgrad)
+tetatemp = 25000.
 
 # Facteur d'amplification de la dissip en haut du modele
-  dissip_fac_up = 30.
+dissip_fac_up = 30.
 
 # Intervalle (km) pour le changement mid / up de la dissip
-#   dissip_deltaz = 30.
+# dissip_deltaz = 30.
 
 # Pression (Pa) au bas la transition mid / up
-   dissip_pupstart = 1.e1
+dissip_pupstart = 1.e1
 
-# coefficient pour gamdissip                                            
-  coefdis=0.
+# Coefficient pour gamdissip
+coefdis = 0.
 
-# choix du shema d'integration temporelle (Matsuno ou Matsuno-leapfrog) 
-  purmats=.false.
+# Choix du shema d'integration temporelle (Matsuno ou Matsuno-leapfrog)
+purmats = .false.
 
-# avec ou sans physique                                                 
-   physic=.true.
+# Avec ou sans physique
+physic = .true.
 
-# periode de la physique (en pas)                                       
-  iphysiq=40
+# Periode de la physique (en pas)
+iphysiq = 40
 
-# Titan: marees gravitationnelles
-  tidal=.true.
+# Titan : marees gravitationnelles
+tidal = .true.
 
-# choix d'une grille reguliere                                          
-  grireg=.true.
+# Choix d'une grille reguliere
+grireg = .true.
 
-# frequence (en pas) de l'ecriture du fichier diagfi               
- ecritphy=2000
+# Frequence (en pas) de l'ecriture du fichier diagfi
+ecritphy = 8000
 
-# longitude en degres du centre du zoom                                 
-   clon=0.
+# Longitude en degres du centre du zoom
+clon = 0.
 
-# latitude en degres du centre du zoom                                  
-   clat=0.
+# Latitude en degres du centre du zoom
+clat = 0.
 
-# facteur de grossissement du zoom,selon longitude                      
-  grossismx=1.
+# Facteur de grossissement du zoom, selon longitude
+grossismx = 1.
 
-# facteur de grossissement du zoom ,selon latitude                      
- grossismy=1.
+# Facteur de grossissement du zoom, selon latitude
+grossismy = 1.
 
-#  Fonction  f(y)  hyperbolique  si = .true.  , sinon  sinusoidale         
-  fxyhypb=.false.
+# Fonction f(y) hyperbolique si = .true., sinon sinusoidale
+fxyhypb = .false.
 
-# extension en longitude  de la zone du zoom  ( fraction de la zone totale)
-   dzoomx= 0.
+# Extension en longitude de la zone du zoom (fraction de la zone totale)
+dzoomx = 0.
 
-# extension en latitude de la zone  du zoom  ( fraction de la zone totale)
-   dzoomy=0.
+# Extension en latitude de la zone du zoom (fraction de la zone totale)
+dzoomy = 0.
 
-#  raideur du zoom en  X
-    taux=2.
+# Raideur du zoom en X
+taux = 2.
 
-#  raideur du zoom en  Y
-    tauy=2.
+# Raideur du zoom en Y
+tauy = 2.
 
-#  Fonction  f(y) avec y = Sin(latit.) si = .TRUE. ,  Sinon  y = latit.
-  ysinus= .false.
+# Fonction f(y) avec y = Sin(latit.), si = .true., sinon y = latit.
+ysinus = .false.
 
 # Avec sponge layer
-  callsponge  = .true.
+callsponge = .true.
 
-# Sponge:  mode0(u=v=0), mode1(u=umoy,v=0), mode2(u=umoy,v=vmoy)
-  mode_sponge= 2
+# Sponge : mode0(u=v=0), mode1(u=umoy,v=0), mode2(u=umoy,v=vmoy)
+mode_sponge = 2
 
 # Sponge : nsponge
-  nsponge = 5
+nsponge = 4
 
-# Sponge:  tetasponge (secondes)
-  tetasponge = 10000
+# Sponge : tetasponge (secondes)
+tetasponge = 10000
 
-# some definitions for the physics, in file 'callphys.def'
+# Some definitions for the physics, in file 'callphys.def'
 INCLUDEDEF=callphys.def
Index: trunk/LMDZ.TITAN/deftank/run.def.12
===================================================================
--- trunk/LMDZ.TITAN/deftank/run.def.12	(revision 3085)
+++ trunk/LMDZ.TITAN/deftank/run.def.12	(revision 3090)
@@ -1,6 +1,5 @@
-#
-#----------------------------------------------------------------------- 
-#Parametres de controle du run:                                          
-#------------------------------                                          
+# ----------------------------------------------------------------------- 
+# Parametres de controle du run :
+# ----------------------------------------------------------------------- 
 
 # Planete
@@ -8,120 +7,120 @@
 
 # Nombre de jours d'integration                                         
-     nday=12
+nday = 12
 
-# nombre de pas par jour (multiple de iperiod) ( ici pour  dt = 1 min )      
- day_step = 8000
+# Nombre de pas par jour (multiple de iperiod) (ici pour dt = 1 min)
+day_step = 8000
 
-# periode pour le pas Matsuno (en pas)                                  
-  iperiod=5
+# Periode pour le pas Matsuno (en pas)                        
+iperiod = 5
 
-# periode de sortie des variables de controle (en pas)                  
-  iconser=500
+# Periode de sortie des variables de controle (en pas)
+iconser = 1000
 
-# periode d'ecriture du fichier histoire (en jour)                      
-    iecri=100
+# Periode d'ecriture du fichier histoire (en jour)
+iecri = 100
 
-# periode de stockage fichier histmoy (en jour)                         
- periodav=60.
+# Periode de stockage fichier histmoy (en jour)
+periodav = 60.
 
-# periode de la dissipation (en pas)                                    
-  dissip_period=5
+# Periode de la dissipation (en pas)
+dissip_period = 5
 
-# choix de l'operateur de dissipation (star ou  non star )              
- lstardis=.true.
+# Choix de l'operateur de dissipation (star ou non star)
+lstardis = .true.
 
-# avec ou sans coordonnee hybrides
- hybrid=.true.
+# Avec ou sans coordonnee hybrides
+hybrid = .true.
 
-# nombre d'iterations de l'operateur de dissipation   gradiv            
-nitergdiv=1
+# Nombre d'iterations de l'operateur de dissipation gradiv
+nitergdiv = 1
 
-# nombre d'iterations de l'operateur de dissipation  nxgradrot          
-nitergrot=2
+# Nombre d'iterations de l'operateur de dissipation nxgradrot
+nitergrot = 2
 
-# nombre d'iterations de l'operateur de dissipation  divgrad            
-   niterh=2
+# Nombre d'iterations de l'operateur de dissipation divgrad
+niterh = 2
 
-# temps de dissipation des plus petites long.d ondes pour u,v (gradiv)  
- tetagdiv=50000.
+# Temps de dissipation des plus petites long. d'ondes pour u,v (gradiv)
+tetagdiv = 25000.
 
-# temps de dissipation des plus petites long.d ondes pour u,v(nxgradrot)
- tetagrot=50000.
+# Temps de dissipation des plus petites long. d'ondes pour u,v (nxgradrot)
+tetagrot = 25000.
 
-# temps de dissipation des plus petites long.d ondes pour  h ( divgrad) 
- tetatemp=50000.
+# Temps de dissipation des plus petites long. d'ondes pour h (divgrad)
+tetatemp = 25000.
 
 # Facteur d'amplification de la dissip en haut du modele
-  dissip_fac_up = 30.
+dissip_fac_up = 30.
 
 # Intervalle (km) pour le changement mid / up de la dissip
-#   dissip_deltaz = 50.
+# dissip_deltaz = 30.
 
 # Pression (Pa) au bas la transition mid / up
-   dissip_pupstart = 1.e1
+dissip_pupstart = 1.e1
 
-# coefficient pour gamdissip                                            
-  coefdis=0.
+# Coefficient pour gamdissip
+coefdis = 0.
 
-# choix du shema d'integration temporelle (Matsuno ou Matsuno-leapfrog) 
-  purmats=.false.
+# Choix du shema d'integration temporelle (Matsuno ou Matsuno-leapfrog)
+purmats = .false.
 
-# avec ou sans physique                                                 
-   physic=.true.
+# Avec ou sans physique
+physic = .true.
 
-# periode de la physique (en pas)                                       
-  iphysiq=40
+# Periode de la physique (en pas)
+iphysiq = 40
 
-# Titan: marees gravitationnelles
-  tidal=.true.
+# Titan : marees gravitationnelles
+tidal = .true.
 
-# choix d'une grille reguliere                                          
-  grireg=.true.
+# Choix d'une grille reguliere
+grireg = .true.
 
-# frequence (en pas) de l'ecriture du fichier diagfi               
- ecritphy=2000
+# Frequence (en pas) de l'ecriture du fichier diagfi
+ecritphy = 8000
 
-# longitude en degres du centre du zoom                                 
-   clon=0.
+# Longitude en degres du centre du zoom
+clon = 0.
 
-# latitude en degres du centre du zoom                                  
-   clat=0.
+# Latitude en degres du centre du zoom
+clat = 0.
 
-# facteur de grossissement du zoom,selon longitude                      
-  grossismx=1.
+# Facteur de grossissement du zoom, selon longitude
+grossismx = 1.
 
-# facteur de grossissement du zoom ,selon latitude                      
- grossismy=1.
+# Facteur de grossissement du zoom, selon latitude
+grossismy = 1.
 
-#  Fonction  f(y)  hyperbolique  si = .true.  , sinon  sinusoidale         
-  fxyhypb=.false.
+# Fonction f(y) hyperbolique si = .true., sinon sinusoidale
+fxyhypb = .false.
 
-# extension en longitude  de la zone du zoom  ( fraction de la zone totale)
-   dzoomx= 0.
+# Extension en longitude de la zone du zoom (fraction de la zone totale)
+dzoomx = 0.
 
-# extension en latitude de la zone  du zoom  ( fraction de la zone totale)
-   dzoomy=0.
+# Extension en latitude de la zone du zoom (fraction de la zone totale)
+dzoomy = 0.
 
-#  raideur du zoom en  X
-    taux=2.
+# Raideur du zoom en X
+taux = 2.
 
-#  raideur du zoom en  Y
-    tauy=2.
+# Raideur du zoom en Y
+tauy = 2.
 
-#  Fonction  f(y) avec y = Sin(latit.) si = .TRUE. ,  Sinon  y = latit.
-  ysinus= .false.
+# Fonction f(y) avec y = Sin(latit.), si = .true., sinon y = latit.
+ysinus = .false.
 
 # Avec sponge layer
-  callsponge  = .true.
+callsponge = .true.
 
-# Sponge:  mode0(u=v=0), mode1(u=umoy,v=0), mode2(u=umoy,v=vmoy)
-  mode_sponge= 2
+# Sponge : mode0(u=v=0), mode1(u=umoy,v=0), mode2(u=umoy,v=vmoy)
+mode_sponge = 2
 
 # Sponge : nsponge
-  nsponge = 5
+nsponge = 4
 
-# Sponge:  tetasponge (secondes)
-  tetasponge = 10000
+# Sponge : tetasponge (secondes)
+tetasponge = 10000
 
-# some definitions for the physics, in file 'callphys.def'
+# Some definitions for the physics, in file 'callphys.def'
 INCLUDEDEF=callphys.def
Index: trunk/LMDZ.TITAN/deftank/z2sig.def
===================================================================
--- trunk/LMDZ.TITAN/deftank/z2sig.def	(revision 3085)
+++ trunk/LMDZ.TITAN/deftank/z2sig.def	(revision 3090)
@@ -1,7 +1,7 @@
- 40.00000      H: atmospheric scale height (km) (used as a reference only)
-  0.040000000     Typical log(sigma) for 1st layer (z=H*log(sigma))
-  0.240000000     Typical log(sigma) for 2nd layer, etc...
-  0.640000000
-  1.600000000
+ 40.00000       H: Atmospheric scale height [km] --> used as a reference only
+  0.040000000   Typical log(sigma) for 1st layer (z = H*log(sigma)),
+  0.240000000   Typical log(sigma) for 2nd layer,
+  0.640000000   Typical log(sigma) for 3rd layer,
+  1.600000000   etc...
   3.600000000
   7.200000000